Bug 495801 - Review Request: json - JavaScript Object Notation
Review Request: json - JavaScript Object Notation
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Lillian Angel
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-04-14 16:52 EDT by Andrew Overholt
Modified: 2015-04-14 02:39 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-04-17 13:10:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
langel: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Andrew Overholt 2009-04-14 16:52:58 EDT
Spec URL: http://overholt.fedorapeople.org/json.spec
SRPM URL: http://overholt.fedorapeople.org/json-2-1.fc10.src.rpm
Description: JSON (JavaScript Object Notation) is a lightweight data-interchange format. It is based on a subset of the JavaScript Programming Language, Standard
ECMA-262 3rd Edition - December 1999.  JSON is a text format that is 
completely language independent but uses conventions that are familiar to 
programmers of the C-family of languages including C, C++, C#, Java, 
JavaScript, Perl, Python, and many others.

Note:  I based this on the JPackage .spec but used the Apache-licensed source zip instead of the "you must use this for good"-licensed one.
Comment 1 Lillian Angel 2009-04-15 12:33:54 EDT
Just a few questions inline (marked with XXXX).


* 1 Packaging Guidelines
  o 1.1 Naming
	ok
  o 1.2 Version and Release
	ok
  o 1.3 Legal
	ok
  o 1.4 No inclusion of pre-built binaries or libraries
	ok
  o 1.5 Spec Legibility
	ok
  o 1.6 Writing a package from scratch
	ok
  o 1.7 Modifying an existing package
	n/a
  o 1.8 Architecture Support
	ok
  o 1.9 Filesystem Layout
	ok
  o 1.10 Use rpmlint
	none!
  o 1.11 Changelogs
	ok
  o 1.12 Tags
	ok
  o 1.13 BuildRoot tag
	ok
  o 1.14 %clean
	ok
  o 1.15 Requires
	ok
  o 1.16 BuildRequires
	ok
  XXXX 1.17 Summary and description
  	Is the javadoc summary correct?
  o 1.18 Encoding
	ok
  XXXX 1.19 Documentation
	None. is there any?
  o 1.20 Compiler flags
	ok
  o 1.21 Debuginfo packages
	n/a
  o 1.22 Devel Packages
	n/a
  o 1.23 Requiring Base Package
	n/a
  o 1.24 Shared Libraries
	ok
  o 1.25 Packaging Static Libraries
	ok
  o 1.26 Duplication of system libraries
	n/a
  o 1.27 Beware of Rpath
	n/a
  o 1.28 Configuration files
	ok
  o 1.29 Initscripts
	ok
  o 1.30 Desktop files
	n/a
  o 1.31 Macros
	ok
  o 1.32 %global preferred over %define
	ok
  o 1.33 Handling Locale Files
	n/a
  o 1.34 Timestamps
	n/a
  o 1.35 Parallel make
	n/a
  o 1.36 Scriptlets
	n/a
  o 1.37 Conditional dependencies
	n/a
  o 1.38 Build packages with separate user accounts
	n/a
  o 1.39 Relocatable packages
	n/a
  o 1.40 Code Vs Content
	ok
  XXXX 1.41 File and Directory Ownership
        + 1.41.1 Duplicate Files
		ok
        + 1.41.2 File Permissions
		Should use: %defattr(-,root,root,-) not %defattr(-,root,root)
  o 1.42 Users and Groups
	n/a
  o 1.43 Web Applications
	n/a
  o 1.44 Conflicts
	n/a
  o 1.45 No External Kernel Modules
	n/a
  o 1.46 No Files or Directories under /srv
	n/a
  o 1.47 Bundling of multiple projects
	n/a
  o 1.48 All patches should have an upstream bug link or comment
	no patches.
  o 1.49 Use of Epochs
	ok
  o 1.50 Symlinks
	n/a
  o 1.51 Application Specific Guidelines
	n/a


All ok:

* MUST: rpmlint must be run on every package. The output should be posted in the review.[1]
* MUST: The package must be named according to the Package Naming Guidelines .
* MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
* MUST: The package must meet the Packaging Guidelines .
* MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
* MUST: The License field in the package spec file must match the actual license. [3]
* MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
* MUST: The spec file must be written in American English. [5]
* MUST: The spec file for the package MUST be legible. [6]
* MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
* MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
* MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
* MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
* MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
* MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
* MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [11]
* MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
* MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
* MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
* MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
* MUST: Each package must consistently use macros. [16]
* MUST: The package must contain code, or permissable content. [17]
* MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
* MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
* MUST: Header files must be in a -devel package. [19]
* MUST: Static libraries must be in a -static package. [20]
* MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]
* MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
* MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
* MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
* MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [23]
* MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
* MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
* MUST: All filenames in rpm packages must be valid UTF-8. [26]

* SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]
* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [28]
* SHOULD: The reviewer should test that the package builds in mock. [29]
* SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [31]
* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [21]
* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32]
Comment 2 Andrew Overholt 2009-04-15 13:01:59 EDT
(In reply to comment #1)
>   XXXX 1.17 Summary and description
>    Is the javadoc summary correct?

It looks okay to me.

>   XXXX 1.19 Documentation
>  None. is there any?

No.

>   XXXX 1.41 File and Directory Ownership
>         + 1.41.2 File Permissions
>   Should use: %defattr(-,root,root,-) not %defattr(-,root,root)

Fixed:

http://overholt.fedorapeople.org/json.spec
http://overholt.fedorapeople.org/json-2-1.fc10.src.rpm
Comment 3 Lillian Angel 2009-04-15 13:03:50 EDT
APPROVED.
Comment 4 Andrew Overholt 2009-04-15 13:25:15 EDT
New Package CVS Request
=======================
Package Name: json
Short Description: JavaScript Object Notation Java implementation
Owners: overholt
Branches: 
InitialCC: ebaron, langel
Comment 5 Kevin Fenzi 2009-04-16 00:32:11 EDT
cvs done.
Comment 6 Andrew Overholt 2009-04-17 13:10:50 EDT
Built in rawhide:

http://koji.fedoraproject.org/koji/taskinfo?taskID=1304544
Comment 7 Milos Jakubicek 2009-05-19 13:45:40 EDT
Package Change Request
======================
Package Name: json
New Branches: F-9 F-10 F-11
Owners: overholt mjakubicek
Comment 8 Kevin Fenzi 2009-05-20 01:44:03 EDT
cvs done.

Note You need to log in before you can comment on or make changes to this bug.